"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var core_exports = {};
__export(core_exports, {
  S: () => S,
  default: () => core_default
});
module.exports = __toCommonJS(core_exports);
let stack = [];
function getCurrentConext() {
  let context = stack[stack.length - 1];
  return context;
}
function create(value) {
  let listeners = /* @__PURE__ */ new Set();
  function read() {
    let context = getCurrentConext();
    if (context) {
      listeners.add(context);
    }
    return value;
  }
  function write(newVal) {
    value = newVal;
    listeners.forEach((fn) => fn());
  }
  return {
    get value() {
      return read();
    },
    set value(val) {
      write(val);
    },
    toString() {
      return read();
    },
    valueOf() {
      return read();
    }
  };
}
function run(context) {
  try {
    stack.push(context);
    return context();
  } finally {
    stack.pop();
  }
}
function map(fn) {
  let s = create(void 0);
  run(() => s.value = fn());
  return s;
}
let S = Object.assign(create, { run, map });
var core_default = S;
