let stack = [];
function getCurrentConext() {
  let context = stack[stack.length - 1];
  return context;
}
function create(value) {
  let listeners = /* @__PURE__ */ new Set();
  function read() {
    let context = getCurrentConext();
    if (context) {
      listeners.add(context);
    }
    return value;
  }
  function write(newVal) {
    value = newVal;
    listeners.forEach((fn) => fn());
  }
  return {
    get value() {
      return read();
    },
    set value(val) {
      write(val);
    },
    toString() {
      return read();
    },
    valueOf() {
      return read();
    }
  };
}
function run(context) {
  try {
    stack.push(context);
    return context();
  } finally {
    stack.pop();
  }
}
function map(fn) {
  let s = create(void 0);
  run(() => s.value = fn());
  return s;
}
let S = Object.assign(create, { run, map });
var core_default = S;
export {
  S,
  core_default as default
};
