"use strict";
(() => {
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __esm = (fn, res) => function __init() {
    return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
  };
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };

  // core.ts
  function getCurrentConext() {
    let context = stack[stack.length - 1];
    return context;
  }
  function create(value) {
    let listeners = /* @__PURE__ */ new Set();
    function read() {
      let context = getCurrentConext();
      if (context) {
        listeners.add(context);
      }
      return value;
    }
    function write(newVal) {
      value = newVal;
      listeners.forEach((fn) => fn());
    }
    return {
      get value() {
        return read();
      },
      set value(val) {
        write(val);
      },
      toString() {
        return read();
      },
      valueOf() {
        return read();
      }
    };
  }
  function run(context) {
    try {
      stack.push(context);
      return context();
    } finally {
      stack.pop();
    }
  }
  function map(fn) {
    let s = create(void 0);
    run(() => s.value = fn());
    return s;
  }
  var stack, S, core_default;
  var init_core = __esm({
    "core.ts"() {
      "use strict";
      stack = [];
      S = Object.assign(create, { run, map });
      core_default = S;
    }
  });

  // browser.ts
  var require_browser = __commonJS({
    "browser.ts"() {
      init_core();
      window.S = core_default;
    }
  });
  require_browser();
})();
